## Do not edit this file manually.
## It has been automatically generated from *.org sources.

exampleModels <- list(
    ## formerly moWL          
    WL_ibm = new("MixARGaussian", 
                  prob   = c(0.5439, 0.4176, 0.0385),                     # moWLprob,
                  scale  = c(4.8227, 6.0082, 18.1716),                    # moWLsigma,
                  arcoef = list(c(0.6792, 0.3208), c(1.6711, -0.6711), 1) # moWLar
                  ),
    
    WL_A = new("MixARGaussian"                         # WongLi, model A
              , prob = c(0.5, 0.5)
              , scale = c(5, 1)
              , shift = c(0, 0)
              , arcoef = list(c(0.5), c(1.1))
                ),

    WL_B = new("MixARGaussian"                         # WongLi, model B
              , prob = c(0.75, 0.25)
              , scale = c(5, 1)
              , shift = c(0, 0)
              , arcoef = list(c(0.5), c(1.4))
                ),

    WL_I = new("MixARGaussian"                          # WongLi, model I
              , prob = c(0.4, 0.3, 0.3)
              , scale = c(1, 1, 5)
              , shift = c(0, 0, -5)
              , arcoef = list(c(0.9, -0.6), c(-0.5), c(1.50, -0.74, 0.12))
                ),
    
    WL_II = new("MixARGaussian"                         # WongLi, model II
               , prob = c(0.4, 0.3, 0.3)
               , scale = c(1, 1, 5)
               , shift = c(5, 0, -5)
               , arcoef = list(c(0.9, -0.6), c(-0.7, 0), c( 0, 0.80))
                 )
)

exampleModels$WL_ibm_gen <- 
##    moWLgen <-
    new("MixARgen",
        prob=exampleModels$WL_ibm@prob,
        scale=exampleModels$WL_ibm@scale,
        arcoef=exampleModels$WL_ibm@arcoef,
        dist=list(dist_norm)
        )

exampleModels$WL_ibm_t3v <- 
##    moWLt3v <-
    new("MixARgen",
        prob=exampleModels$WL_ibm@prob,
        scale=exampleModels$WL_ibm@scale,
        arcoef=exampleModels$WL_ibm@arcoef,
        dist=list(fdist_stdt(3,fixed=FALSE)))

exampleModels$WL_ibm_tf <- 
##    moWLtf <-
    new("MixARgen",
        prob=exampleModels$WL_ibm@prob,
        scale=exampleModels$WL_ibm@scale,
        arcoef=exampleModels$WL_ibm@arcoef,
        dist=list(generator=function(par) fn_stdt(par,fixed=FALSE),param=c(20,30,40)))

exampleModels$WL_At <-
##    moT_A <-
        new("MixARgen"
               , prob = c(0.5,0.5)
               , scale = c(1, 2)
               , shift = c(0, 0)
               , arcoef = list(c(-0.5), c(1.1))
                                                                  #  t4, t8
               , dist=list(generator=function(par) fn_stdt(par,fixed=FALSE),param=c(4,8))
               )

exampleModels$WL_Bt_1 <-
##    moT_B <-
        new("MixARgen"
               , prob = c(0.3, 0.3, 0.4)
               , scale = c(2, 1, 0.5)
               , shift = c(5, -5, 0)
               , arcoef = list(c(0.5, 0.24), c(-0.9), c(1.5, -0.74, 0.12))
                                        # t4, t6, t10
                 # dist=list(generator=function(par) fn_stdt(par,fixed=FALSE),param=c(4,6,10))
               , dist = distlist(c("stdt", "stdt", "stdt"), c(4,6,10))
               )

exampleModels$WL_Bt_2 <-
##    moT_B2 <-
        new("MixARgen"
               , prob = c(0.3, 0.3, 0.4)
               , scale = c(2, 1, 0.5)
               , shift = c(5, -5, 0)
               , arcoef = list(c(0.5, 0.24), c(-0.9), c(1.5, -0.74, 0.12))
                                        # t4, t4, t10
               , dist=list(generator=function(par) ft_stdt(par,
                                                           fixed = c(FALSE, TRUE),
                                                           n = 3,
                                                   tr = function(x,k) if(k<3) x[1] else x[2]),
                           param = c(4, 10))
               )

exampleModels$WL_Bt_3 <-
##    moT_B3 <-
        new("MixARgen"
               , prob = c(0.3, 0.3, 0.4)
               , scale = c(2, 1, 0.5)
               , shift = c(5, -5, 0)
               , arcoef = list(c(0.5, 0.24), c(-0.9), c(1.5, -0.74, 0.12))
                                        # t4, t4, t10
               , dist = distlist("stdt", c(4,10), fixed = c(FALSE, TRUE), tr = c(1,1,2))
               )

exampleModels$WL_Ct_1 <-
##    moT_C1 <-
        new("MixARgen"
              , prob = c(0.3, 0.3, 0.4)
              , scale = c(2, 1, 0.5)
              , shift = c(5, -5, 0)
              , arcoef = list(c(0.5, 0.24), c(-0.9), c(1.5, -0.74, 0.12))
                                        # t4, t7, N(0,1)
              , dist = distlist(c("stdt", "stdt", "stdnorm"), c(4,7))
              )

exampleModels$WL_Ct_2 <-
##    moT_C2 <-
        new("MixARgen"
              , model = exampleModels$WL_Bt_1
              , dist = distlist(c("stdt", "stdt", "stdnorm"), c(4,7))  # t4, t7, N(0,1)
              )

exampleModels$WL_Ct_3 <-
##    moT_C3 <-
        new("MixARGaussian", model = exampleModels$WL_Bt_1)




